package org.warp.cowdb.lists;

import it.unimi.dsi.fastutil.longs.LongArrayList;
import org.warp.cowdb.IDatabase;
import org.warp.cowdb.IDatabaseTools;
import org.warp.jcwdb.ann.DBDataType;
import org.warp.jcwdb.ann.DBField;

import java.io.IOException;

public class ObjectCowList<T> extends CowList<T> {

	@DBField(id = 0, type = DBDataType.REFERENCES_LIST)
	private LongArrayList indices;

	@Override
	protected LongArrayList getIndices() {
		return indices;
	}

	public ObjectCowList() {
		super();
	}

	public ObjectCowList(IDatabaseTools databaseTools) throws IOException {
		super(databaseTools);
		indices = new LongArrayList();
	}

	@Override
	protected T loadItem(long uid) throws IOException {
		return databaseTools.getObjectsIO().loadObject(uid);
	}

	@Override
	protected void writeItemToDisk(long uid, T item) throws IOException {
		databaseTools.getObjectsIO().setObject(uid, item);
	}
}
