package org.warp.jcwdb.tests;

import org.warp.cowdb.EnhancedObject;
import org.warp.cowdb.EnhancedObjectUpgrader;
import org.warp.cowdb.IDatabaseTools;
import org.warp.jcwdb.ann.DBClass;
import org.warp.jcwdb.ann.DBDataType;
import org.warp.jcwdb.ann.DBField;
import org.warp.jcwdb.ann.DBPrimitiveField;
import org.warp.jcwdb.ann.DBPrimitiveType;

import java.io.IOException;

@DBClass(version = 1)
public class V2Class extends EnhancedObject {
	@DBPrimitiveField(id = 0, type = DBPrimitiveType.LONG)
	public long field1;

	@DBPrimitiveField(id = 1, type = DBPrimitiveType.INTEGER)
	public int field2;

	@DBField(id = 0, type = DBDataType.OBJECT)
	public String field4;

	public V2Class() {

	}

	public V2Class(IDatabaseTools databaseTools) throws IOException {
		super(databaseTools);
	}

	@Override
	public void onUpgrade(int oldObjectVersion, EnhancedObjectUpgrader enhancedObjectUpgrader) throws IOException {
		switch (oldObjectVersion) {
			case 0: {
				field1 = (long) enhancedObjectUpgrader.getPrimitiveInt(2);
				field2 = enhancedObjectUpgrader.getPrimitiveInt(0);
				field4 = (String) enhancedObjectUpgrader.getField(0, DBDataType.OBJECT);
				break;
			}
		}
	}
}
